#!/usr/bin/env python

import sys, os
import simplify
import fixnames
import viewer
from annotate import AnnotationError, annotate_all as aa

def makedoc(viewer, module, builtins):
    try:
        dirname = "%s-docs" % module.name
        if not os.path.exists(dirname):
            os.mkdir(dirname)
        viewer.makedoc(module, os.path.join(dirname, "%s%shtml" % (module.name, os.path.extsep)))
        viewer.makedoc(builtins, os.path.join(dirname, "%s%shtml" % (builtins.name, os.path.extsep)))
    except viewer.ViewerError, exc:
        raise

if __name__ == "__main__":

    builtins = simplify.simplify(os.path.join("lib", "builtins.py"), 1)
    module = simplify.simplify(sys.argv[1])
    fixnames.fix(builtins)
    fixnames.fix(module, builtins)

    stream = sys.stdout
    v = viewer.Viewer(stream)

    if "-a" in sys.argv:
        try:
            aa([module], builtins)
        except AnnotationError, exc:
            v.report(exc)

    if "-d" in sys.argv:
        makedoc(viewer, module, builtins)

# vim: tabstop=4 expandtab shiftwidth=4
